#include "cGame.h"
#include <iomanip>

using namespace std;


cMatrix<double> InitGrid3(cMatrix<double> input)
{
	cMatrix<double> res = input;
	res.Resize(nROW, nCOL, 0);

	if (input.size() == 0)
	{
	res[0][0] =    27.0643; 
	res[1][0] =   -4.50207; res[1][1] =   -16.6209; 
	res[2][0] =   -4.94808; res[2][1] =   -12.8019; res[2][2] =    5.02245; 
	res[3][0] =    14.6643; res[3][1] =   -11.8225; res[3][2] =  -0.250991; res[3][3] =  -0.785909; 
//TIME: 436609

		  /*
	res[0][0] =    23.2344; 
	res[1][0] =   -3.69439; res[1][1] =   -17.2441; 
	res[2][0] =   -5.10631; res[2][1] =   -10.6033; res[2][2] =   -1.63993; 
	res[3][0] =    19.0306; res[3][1] =   -7.73482; res[3][2] =    6.50128; res[3][3] =    1.44682; 
	//TIME: 276172
	*/

		  /*
		  //for corner bonus added
	res[0][0] =    27.0323; 
	res[1][0] =   -4.85872; res[1][1] =   -12.7205; 
	res[2][0] =   -4.53146; res[2][1] =   -11.6486; res[2][2] =    1.99817; 
	res[3][0] =    13.0726; res[3][1] =   -14.9568; res[3][2] =   -2.27627; res[3][3] =    1.56109; 
	//TIME: 12516
	*/
	}

	int r, c;

	//get the corner, i.e. 4x4 matrix filled
	for(r=0; r<nROW/2; r++)
		for(c=r+1; c<nCOL/2; c++)
			res[r][c] = res[c][r];

	//get the left half filled
	for(r=nROW/2; r<nROW; r++)
		for(c=0; c<nCOL/2; c++)
			res[r][c] = res[nROW-r-1][c];

	//get the entire filled
	for(r=0; r<nROW; r++)
		for(c=nCOL/2; c<nCOL; c++)
			res[r][c] = res[r][nCOL-c-1];

	return res;
}

cMatrix<double> InitGrid2(cMatrix<double> input)
{
	cMatrix<double> res = input;
	res.Resize(nROW, nCOL, 0);

	if (input.size() == 0)
	{

		/*
	//for eval2
	res[0][0] =    25.1309; 
	res[1][0] =   -5.82591; res[1][1] =   -9.42345; 
	res[2][0] =   -1.32907; res[2][1] =   -2.54628; res[2][2] =  0.0623483; 
	res[3][0] =    8.86331; res[3][1] =   -3.46086; res[3][2] =   0.792597; res[3][3] =   0.820598; 
	*/

	res[0][0] =    25.1309; 
	res[1][0] =   -4.66327; res[1][1] =    -9.3608; 
	res[2][0] =   -1.98504; res[2][1] =   -6.96296; res[2][2] =   0.151777; 
	res[3][0] =    11.7463; res[3][1] =   -6.10546; res[3][2] =  -0.234369; res[3][3] =   -1.78741; 
//TIME: 1536218
	}

	int r, c;

	//get the corner, i.e. 4x4 matrix filled
	for(r=0; r<nROW/2; r++)
		for(c=r+1; c<nCOL/2; c++)
			res[r][c] = res[c][r];

	//get the left half filled
	for(r=nROW/2; r<nROW; r++)
		for(c=0; c<nCOL/2; c++)
			res[r][c] = res[nROW-r-1][c];

	//get the entire filled
	for(r=0; r<nROW; r++)
		for(c=nCOL/2; c<nCOL; c++)
			res[r][c] = res[r][nCOL-c-1];

	return res;
}


//set a value to each grid
//NOTE: changing nROW or nCOL might result in failure of this function
cMatrix<double> InitGrid(cMatrix<double> input)
{
	cMatrix<double> res = input;
	res.Resize(nROW, nCOL, 0);

	if (input.size() == 0)
	{

	// for eval1
	res[0][0] =    25.7957; 
	res[1][0] =   -5.72912; res[1][1] =   -9.23786; 
	res[2][0] =   -1.32907; res[2][1] =   -2.66268; res[2][2] =   0.481184; 
	res[3][0] =    8.42829; res[3][1] =   -3.63214; res[3][2] =   0.544214; res[3][3] =   0.538515; 
	//
	}

	int r, c;

	//get the corner, i.e. 4x4 matrix filled
	for(r=0; r<nROW/2; r++)
		for(c=r+1; c<nCOL/2; c++)
			res[r][c] = res[c][r];

	//get the left half filled
	for(r=nROW/2; r<nROW; r++)
		for(c=0; c<nCOL/2; c++)
			res[r][c] = res[nROW-r-1][c];

	//get the entire filled
	for(r=0; r<nROW; r++)
		for(c=nCOL/2; c<nCOL; c++)
			res[r][c] = res[r][nCOL-c-1];

	return res;
}

double Rand(double min, double max)
{
	int r = rand();
	if (r > 32003)
	{
		return Rand(min, max);
	}
	else
	{
		double ratio = (double(r) / 32003.0);
		return min + (max - min) * ratio;
	}
}


bool cGame::SearchGrid(const clock_t duration)
{
	//make mGrid2 slight different from mGrid1
	mGrid2 = mGrid1;

	//randomly choose a vertex to be change
	//NOTE: this favor change in corner over center
	int r=rand() % nROW/2;
	int c=rand() % (r+1);

	//make mGrid2 symmetrical
	const double RANGE = 1.0;
	mGrid2[r][c] += Rand(-RANGE, RANGE);
	mGrid2 = InitGrid(mGrid2);

	//test which one is better

	//play the first game
	Load("new.txt");
	for(;;)
	{
		if (bEnd == true) break;

		//ask comp to decide of move
		pair<int, int> move;
		if (player == gBLACK) move = Play1();
		else if (player == gWHITE) move = Play2();
		else assert(false);

		//make the move
		MakeMove(move.first, move.second);
	}

	//if tie, well, count as win, since I want to favor original
	bool win1 = (board.Count(gBLACK) >= board.Count(gWHITE));
	//OutGame();

	//please the second game
	//play the first game
	Load("new.txt");
	for(;;)
	{
		if (bEnd == true) break;

		//ask comp to decide of move
		pair<int, int> move;
		if (player == gWHITE) move = Play1();
		else if (player == gBLACK) move = Play2();
		else assert(false);

		//make the move
		MakeMove(move.first, move.second);
	}

	//if tie, well, count as win, since I want to favor original
	bool win2 = (board.Count(gWHITE) >= board.Count(gBLACK));
	//OutGame();

	//change only if orginal lost both game
	if (!win1 && !win2)
	{
		mGrid1 = mGrid2;
	}
	else
	{
		mGrid2 = mGrid1;
	}

	if (!win1 && !win2)
	{
		//output the grid to screen and file
		ofstream oGrid("grid.txt", ios::app);

		oGrid << "TIME: " << duration << endl;

		for(int i=0; i<nROW/2; i++)
		{
			oGrid << '\t';
			for(int j=0; j<=i; j++)
			{
				//cout << "res[" << i << "]" << "[" << j << "] = ";
				oGrid << "res[" << i << "]" << "[" << j << "] = ";
				
				cout << setw(10) << setprecision(6) << mGrid1[i][j] << "; ";
				oGrid << setw(10) << setprecision(6) << mGrid1[i][j] << "; ";
			}
			cout << endl;
			oGrid << endl;
		}
		oGrid.close();

		return true;
	}
	
	return false;
}

void cGame::Endgame()
{
	bEnd = true;
	player = gBLANK;

//	OutGame();
}

bool cGame::Switch()
{
	if (player == gBLANK)
	{
		Endgame();
		return false;
	}

	//switch the player
	if (player == gBLACK) player = gWHITE;
	else if (player == gWHITE) player = gBLACK;
	else assert(false);

	//however, if there is no valid move, switch back
	cMatrix<bool> mValid;
	mValid.Resize(nROW, nCOL, false);
	int nValid = board.Valid(player, mValid);

	if (nValid == 0)
	{
		//switch the player again
		if (player == gBLACK) player = gWHITE;
		else if (player == gWHITE) player = gBLACK;
		else assert(false);

		nValid = board.Valid(player, mValid);

		//if both player can't move, game end!
		if (nValid == 0)
		{
			Endgame();
			return false;
		}
	}

	return true;
}

//make a move
bool cGame::MakeMove(int r, int c)
{
	if (r < 0 || c < 0) return false;
	if (r >= nROW || c >= nROW) return false;

	if (bEnd) return false;

	bool valid = board.MakeMove(player, r, c);
	if (!valid) return false;
	else
	{
		//figure out the index for history
		int n = nROW * nCOL - board.Count(gBLANK);
		n -= 4; //since we start with 4 pieces
		n -= 1; //to account of the additional piece that is placed

		int curindex = n;

		if (history.size() < curindex)
		{
			//incomplete history
			assert(false);
		}
		else
		{
			if (history.size() > curindex)
			{
				if (history[curindex].r == r &&
					history[curindex].c == c &&
					history[curindex].p == player)
				{
					Switch();
					return true;
					//do nothing
				}
				else //if this is a new move
				{
					history.erase(history.begin()+curindex, history.end());
				}
			}

			//if it gets to this point, need item should be added
			assert(history.size() == curindex);

			//record info for undo
			cAction act;
			act.r = r;
			act.c = c;
			act.p = player;

			history.push_back(act);

		}

		Switch();
		return true;
	}
}

pair<int, int> cGame::LastMove(void)
{
	pair<int, int> bad(-1, -1);

	//figure out the number of moves made
	int n = nROW * nCOL - board.Count(gBLANK); n -= 4;
	if (history.size() < n) return bad;

	if (n == 0) return bad;

	return pair<int, int>(history[n-1].r, history[n-1].c);
}


bool cGame::Undo(cPlayer p)
{
	//if the history is missing (possibly due to previous version
	if (history.size() + 4 < board.Count(gBLACK) + board.Count(gWHITE)) return false;

	//figure out the index for undo
	int n = nROW * nCOL - board.Count(gBLANK);
	n -= 4;

	//last entry for undo
	int last = (n-1)-1;
	int index = -2; //-1 is reserved for new game
	
	if (p == gBLANK) index = last;
	else
	{
		for(int i=last; i>=0; i--)
		{
			if (history[i].p == p)
			{
				index = i - 1;
				break;
			}
		}
	}

	if (index <= -2) return false; //undo fail
	else
	{
		//since history will be deleted when game reset
		vector<cAction> backup = history;

		if (index == -1) NewGame();
		else
		{

			//reset the game
			NewGame();
			for(int m=0; m<=index; m++)
			{
				if (!MakeMove(backup[m].r, backup[m].c))
				{
					assert(false);
				}
			}
		}

		//copy the history back
		history = backup;

		return true;
	}
}

bool cGame::Redo(cPlayer p)
{
	//if the history is missing (possibly due to previous version
	if (history.size() + 4 < board.Count(gBLACK) + board.Count(gWHITE)) return false;

	//figure out the index for redo
	int n = nROW * nCOL - board.Count(gBLANK);
	n -= 4;

	//the first entry for redo
	int first = (n-1)+1;
	int index = nROW * nCOL;
	
	if (p == gBLANK) index = first;
	else
	{
		for(int i=first;; i++)
		{
			int h = history.size();

			//if index i is too big
			if (history.size() < i) break;

			//if end is reached, just stop at the previous move
			if (history.size() == i)
			{
				index = i-1;
			}

			//unless there is no history to redo
			if (first > index) return false;

			if (history[i].p == p)
			{
				//if you found a move that made by you, stop here
				index = i;
				break;
			}
		}
	}

	//if the resulting index is too big
	if (index >= history.size()) return false; //undo fail
	else
	{
		//make the moves describled in history
		for(int f=first; f<=index; f++)
		{
			int r = history[f].r;
			int c = history[f].c;

			bool suc = MakeMove(r, c);
			assert(suc);
		}

		return true;
	}
}

//output the game
void cGame::OutGame()
{
	if (bEnd)
	{
		int nBlack = board.Count(gBLACK);
		int nWhite = board.Count(gWHITE);

		if (nBlack > nWhite) cout << gBLACK << " wins!" << endl;
		else if (nWhite > nBlack) cout << gWHITE << " wins!" << endl;
		else
		{
			cout << "tie!" << endl;
		}
	}

	cout << "Player: " << player << endl;

	int nBlack = board.Count(gBLACK);
	int nWhite = board.Count(gWHITE);

	cout << gBLACK << " : " << nBlack << endl;
	cout << gWHITE << " : " << nWhite << endl;

	cout << endl;
	cout << board;
}

bool cGame::Load(string fn)
{
	ifstream in(fn.c_str());

	if (in.fail())
	{
		cout << "Unable to open file " << fn << endl;
		return false;
	}

	char ch;

	//get the player
	in >> ch;
	if (ch == 'x' || ch == 'X') player = gBLACK;
	else if (ch == 'o' || ch == 'O') player = gWHITE;
	else if (ch == '-')	player = gBLANK;
	else return false;

	//get the board
	for(int r=0; r<nROW; r++)
	{
		for(int c=0; c<nCOL; c++)
		{
			in >> ch;

			if (ch == 'x' || ch == 'X') board[r][c] = gBLACK;
			else if (ch == 'o' || ch == 'O') board[r][c] = gWHITE;
			else board[r][c] = gBLANK;
		}
	}

	//erase the original history
	history.erase(history.begin(), history.end());

	//read in the history (if exist)
	int hSize;
	in >> hSize;

	if (!in.eof())
	{
		for(int h=0; h<hSize; h++)
		{
			//read in location
			int r, c;
			in >> r >> c;
			
			//read in player
			cPlayer p;
			in >> ch;
			if (ch == 'x' || ch == 'X') p = gBLACK;
			else if (ch == 'o' || ch == 'O') p = gWHITE;
			else return false;

			//set the action appropriately
			cAction act;
			act.r = r;
			act.c = c;
			act.p = p;

			//add to the database
			history.push_back(act);
		}
	}

	//set the endgame flag
	bEnd = false;

	//switch twice to handle the situation when loaded player can not move
	//	or the game ends
	Switch();
	if (!bEnd) Switch();

	return true;
}

bool cGame::Save(string fn)
{
	ofstream out(fn.c_str());

	//save the player
	out << player << endl;

	//save the game
	for(int r=0; r<nROW; r++)
	{
		for(int c=0; c<nCOL; c++)
		{
			if (board[r][c] == gBLANK) out << '-';
			else out << board[r][c];
		}
		out << endl;
	}

	//NOTE that below has all the necessary info to regenerate the game, but above is used for ease of reading file
	//even if below are incorrect or ignored, the file still will load properly
	//save the movement history
	out << history.size() << endl;
	for(int h=0; h<history.size(); h++)
	{
		out << history[h].r << ' ' << history[h].c << ' ' << history[h].p << endl;
	}

	out.close();
	return true;
}

int cGame::Depth()
{
	//count up the number of pieces
	int nBlack = board.Count(gBLACK);
	int nWhite = board.Count(gWHITE);

	//choose a reasonable depth
	int depth;
	if (nBlack + nWhite < 10) depth = nDepth+1;
	else if (nBlack + nWhite > 56) depth = nDepth+8;
	else if (nBlack + nWhite > 52) depth = nDepth+4;
	else if (nBlack + nWhite > 48) depth = nDepth+2;
	else if (nBlack + nWhite > 44) depth = nDepth+1;
	else depth = nDepth;

	return depth;
}

//Comp player 1 plays
pair<int, int> cGame::Play1()
{
	cMatrix<bool> mValid;
	mValid.Resize(nROW, nCOL, false);

	int r = -1, c = -1;
	
	int depth = Depth();

	double nScore = (*fDecide1)(player, board, depth, mGrid1, mValid, fEval1, r, c);

	cout << endl << "1 " << nScore;
	return pair<int, int>(r, c);
}

//Comp 2 plays
pair<int, int> cGame::Play2()
{
	cMatrix<bool> mValid;
	mValid.Resize(nROW, nCOL, false);

	int r = -1, c = -1;
	
	int depth = Depth();

	double nScore = (*fDecide2)(player, board, depth, mGrid2, mValid, fEval2, r, c);

//	cout << "2 " << nScore << endl;
	return pair<int, int>(r, c);
}

//combination of 1 and 2
pair<int, int> cGame::Play3()
{
	cMatrix<bool> mValid;
	mValid.Resize(nROW, nCOL, false);

	int r = -1, c = -1;
	
	int depth = Depth();

	double nScore = (*fDecide1)(player, board, depth, mGrid1, mValid, fEval1, r, c);

	//if it's a dangerous move, let decision 2 decide
	if (mGrid1[r][c] == mGrid1[0][1] ||
		mGrid1[r][c] == mGrid1[1][1])
	{
		double nScore = (*fDecide2)(player, board, depth, mGrid2, mValid, fEval2, r, c);
	}
	
	return pair<int, int>(r, c);
}

//mValid are passed along to avoid memory allocation
double Decide(const cPlayer player, cBoard& board, int depth, cMatrix<double>& mGrid, cMatrix<bool>& mValid, cStrat* eval, int& r_out, int& c_out)
{
	if (depth == 0)
	{
		//this does not use mValid, but actually destroy the content
		return (*eval)(player, board, mGrid, mValid);
	}
	else
	{
		
		//figure out the next player
		cPlayer next;
		if (player == gBLACK) next = gWHITE;
		else if (player == gWHITE) next = gBLACK;

		//note that this call destroy the content of mValid
		vector<cMove> moves = GetOrderMove(player, board, mValid, mGrid);
	
		if (moves.size() == 0)
		{
			int nMove = board.Valid(next, mValid);

			//this has to keep the same depth, otherwise eval doesn't work correctly because eval judge by pieces at the end
			if (nMove != 0)
			{
				return -Decide(next, board, depth, mGrid, mValid, eval, r_out, c_out);
			}
			else
			{
				//this part assumes that r_out and c_out has already been set
				int nPlayer = board.Count(player);
				int nOther = board.Count(next);
				int nDiff = nPlayer - nOther;

				//divide by 64 to avoid overflow
				return INFINITY / (nROW * nCOL) * nDiff;

				/* below does not encourage the comp to win lots of piece, but enforce comp to win
				if (nDiff > 0) return INFINITY;
				else if (board.Count(player) < board.Count(next)) return -INFINITY;
				else return 0;
				*/
			}
		}


		cMove mBest(-1, -1, -1);
		double nScore = -INFINITY*2;

		for(int m=0; m<moves.size(); m++)
		{
			int r = moves[m].r;
			int c = moves[m].c;

			//make the move described by moves[m];
			cMatrix<bool> mUndo;
			mUndo.Resize(nROW, nCOL, false);
			board.Move(player, r, c, mUndo);
			board.Set(r, c, player);

			/* this is a hack to make comp more likely to place corner when there is a chance */
			double cBonus = 0;
			{
				cPlayer other = next;

				int cPlayer = 0;
				int cOther = 0;
				int r, c;

				r = 0; c = 0;
				if (board[r][c] == player) cPlayer++;
				else if (board[r][c] == other) cOther++;
				
				r = nROW-1; c = 0;
				if (board[r][c] == player) cPlayer++;
				else if (board[r][c] == other) cOther++;

				r = 0; c = nCOL-1;
				if (board[r][c] == player) cPlayer++;
				else if (board[r][c] == other) cOther++;
				
				r = nROW-1; c = nCOL-1;
				if (board[r][c] == player) cPlayer++;
				else if (board[r][c] == other) cOther++;

				if (cPlayer >= 1 && cOther == 0)
				{
					cBonus = mGrid[0][0] * cPlayer;
					//cout << "B";
				}
			}
			
			//figure out the result
			double res = -Decide(next, board, depth-1, mGrid, mValid, eval, r_out, c_out) + cBonus;
			
			//flag if update is needed
			bool update = false;

			//set update flag
			if (res > nScore) update = true;
			
			//check for tie
			const double TIECUTOFF = 1.0;
			if (fabs(res - nScore) < TIECUTOFF)
			{
				//if there are more moves avail, there are less change for choosing the later move, since the later move are generally worse
				if (m != 0)
					if (rand() % m == 1) update = true;
			}

			//actual update
			if(update)
			{
				nScore = res;
				mBest = moves[m];
			}

			//undo the move
			board.Remove(r, c);
			board.Undo(mUndo);
		}

		r_out = mBest.r;
		c_out = mBest.c;
		return nScore;
	}
}

double NoRandDecide(const cPlayer player, cBoard& board, int depth, cMatrix<double>& mGrid, cMatrix<bool>& mValid, cStrat* eval, int& r_out, int& c_out)
{
	if (depth == 0)
	{
		//this does not use mValid, but actually destroy the content
		return (*eval)(player, board, mGrid, mValid);
	}
	else
	{
		//figure out the next player
		cPlayer next;
		if (player == gBLACK) next = gWHITE;
		else if (player == gWHITE) next = gBLACK;

		//note that this call destroy the content of mValid
		vector<cMove> moves = GetOrderMove(player, board, mValid, mGrid);
	
		if (moves.size() == 0)
		{
			int nMove = board.Valid(next, mValid);

			//this has to keep the same depth, otherwise eval doesn't work correctly because eval judge by pieces at the end
			if (nMove != 0)	return -Decide(next, board, depth, mGrid, mValid, eval, r_out, c_out);
			else
			{
				//this part assumes that r_out and c_out has already been set
				int nPlayer = board.Count(player);
				int nOther = board.Count(next);
				int nDiff = nPlayer - nOther;

				//divide by 64 to avoid overflow
				return INFINITY / (nROW * nCOL) * nDiff;

				/* below does not encourage the comp to win lots of piece, but enforce comp to win
				if (nDiff > 0) return INFINITY;
				else if (board.Count(player) < board.Count(next)) return -INFINITY;
				else return 0;
				*/
			}
		}


		cMove mBest(-1, -1, -1);
		double nScore = -INFINITY*2;

		for(int m=0; m<moves.size(); m++)
		{
			int r = moves[m].r;
			int c = moves[m].c;

			//make the move described by moves[m];
			cMatrix<bool> mUndo;
			mUndo.Resize(nROW, nCOL, false);
			board.Move(player, r, c, mUndo);
			board.Set(r, c, player);

			//figure out the result
			double res = -Decide(next, board, depth-1, mGrid, mValid, eval, r_out, c_out);
			
			//flag if update is needed
			bool update = false;

			//set update flag
			if (res > nScore) update = true;
			
			//check for tie
			/* this is the no randomization version
			const double TIECUTOFF = 1.0;
			if (fabs(res - nScore) < TIECUTOFF)
			{
				//if there are more moves avail, there are less change for choosing the later move, since the later move are generally worse
				if (m != 0)
					if (rand() % m == 1) update = true;
			}
			*/

			//actual update
			if(update)
			{
				nScore = res;
				mBest = moves[m];
			}

			//undo the move
			board.Remove(r, c);
			board.Undo(mUndo);
		}

		r_out = mBest.r;
		c_out = mBest.c;
		return nScore;
	}
}

bool CompareMove(const cMove& m1, const cMove& m2)
{
	return (m1.priority > m2.priority);
}

//mValid is passed around just so that same memory location is used over and over
vector<cMove> GetOrderMove(const cPlayer& player, cBoard& board, cMatrix<bool>& mValid, cMatrix<double>& mGrid)
{
	vector<cMove> res;

	assert(mGrid.size() == board.size());

	int nValid = board.Valid(player, mValid);

	for(int i=0; i<board.size(); i++)
	{
		assert(board.size() == board[i].size());
		assert(mGrid[i].size() == board[i].size());

		for(int j=0; j<board[i].size(); j++)
		{
			if (mValid[i][j] == true)
			{
				res.push_back(cMove(i, j, mGrid[i][j]));
			}
		}
	}

	sort(res.begin(), res.end(), CompareMove);
	
	//double check if I sorted in the right order
	//assert(res.size() < 2 || res[0].priority >= res[1].priority);
	if(!(res.size() < 2 || res[0].priority >= res[1].priority))
	{
		for(int m=0; m<res.size(); m++)
		{
			cout << res[m].r << ' ' << res[m].c << ' ' << res[m].priority << endl;
		}
	}


	return res;
}

//count up the mobility score
int Mobility(const cPlayer player, cBoard& board, cMatrix<bool>& mValid)
{
	int res = board.Valid(player, mValid);
	return res;
}

double Position(const cPlayer player, cBoard& board, cMatrix<double>& mGrid)
{
	double res = 0;
	int r, c;
	for(r=0; r<nROW; r++)
	{
		for(c=0; c<nCOL; c++)
		{
			if (board[r][c] == player)
			{
				res += mGrid[r][c];
			}
		}
	}

	//add extra negative for corner loc
	for(int i=0; i<=4; i++)
	{
		int x, y;
		switch (i)
		{
		case 0: r=0; c=0; x=1; y=1; break;
		case 1: r=nROW-1, c=nCOL-1; x=-1; y=-1; break;
		case 2: r=0; c=nCOL-1; x=-1; y=1; break;
		case 4: r=nROW-1; c=0; x=1; y=-1; break;
		}
	
		if (board[r][c] == gBLANK)
		{
			
			//triple the negative for occupying those place diagonally adj to corner
			//since there is only 1 constant, the program should still do fine the "optimial"
			const double MUTIPLIER = 3.0;
			if (board[r+y][c+x] == player)
			{
				res += MUTIPLIER * mGrid[r+y][c+x];
			}

			//don't subtract the adj corner piece if the adj edge piece is player's
			if (board[r+y][c] == player && board[r+2*y][c] == player)
			{
				res -= mGrid[r+y][c];
			}

			if (board[r][c+x] == player && board[r][c+2*x] == player)
			{
				res -= mGrid[r][c+x];
			}
/*			
			//if you press diagonal, you are as good as losing the corner
			if (board[r+y][c+x] == player)
			{
				res -= mGrid[r][c];
			}
						
			//similary, if you have an edge next to diagonal, i.e _xxx_x__ this is really bad too
			if (board[r+y][c] == player)
			{
				for(int i=2; i<nROW-1; i++)
				{
					if (board[r+i*y][c] == player) continue;
					else if (board[r+i*y][c] != player)
					{
						if (board[r+i*y+y][c] == player)
						{
							res -= mGrid[r][c];
						}
					}
					else assert(false);
				}
			}

			if (board[r][c+x] == player)
			{
				for(int i=2; i<nCOL-1; i++)
				{
					if (board[r][c+i*x] == player) continue;
					else if (board[r][c+i*x] != player)
					{
						if (board[r][c+i*x+x] == player)
						{
							res -= mGrid[r][c];
						}
					}
					else assert(false);
				}
			}
*/			
		}
	}

	return res;
}

double Position2(const cPlayer player, cBoard& board, cMatrix<double>& mGrid)
{
	double res = 0;
	int r, c;
	for(r=0; r<nROW; r++)
	{
		for(c=0; c<nCOL; c++)
		{
			if (board[r][c] == player)
			{
				res += mGrid[r][c];
			}
		}
	}

	//add extra negative for corner loc
	for(int i=0; i<=4; i++)
	{
		int x, y;
		switch (i)
		{
		case 0: r=0; c=0; x=1; y=1; break;
		case 1: r=nROW-1, c=nCOL-1; x=-1; y=-1; break;
		case 2: r=0; c=nCOL-1; x=-1; y=1; break;
		case 4: r=nROW-1; c=0; x=1; y=-1; break;
		}
	
		if (board[r][c] == gBLANK)
		{
			
			//triple the negative for occupying those place diagonally adj to corner
			//since there is only 1 constant, the program should still do findthe "optimial"
			const double MUTIPLIER = 3.0;
			if (board[r+y][c+x] == player)
			{
				res += MUTIPLIER * mGrid[r+y][c+x];
			}

			//don't subtract the adj corner piece if the adj edge piece is player's
			if (board[r+y][c] == player && board[r+2*y][c] == player)
			{
				res -= mGrid[r+y][c];
			}

			if (board[r][c+x] == player && board[r][c+2*x] == player)
			{
				res -= mGrid[r][c+x];
			}
			
			//if you press diagonal, you are as good as losing the corner
			if (board[r+y][c+x] == player)
			{
				res -= mGrid[r][c];
			}
						
			//similary, if you have an edge next to diagonal, i.e _xxx_x__ this is really bad too
			if (board[r+y][c] == player)
			{
				for(int i=2; i<nROW-1; i++)
				{
					if (board[r+i*y][c] == player) continue;
					else if (board[r+i*y][c] != player)
					{
						if (board[r+i*y+y][c] == player)
						{
							res -= mGrid[r][c];
						}
					}
					else assert(false);
				}
			}

			if (board[r][c+x] == player)
			{
				for(int i=2; i<nCOL-1; i++)
				{
					if (board[r][c+i*x] == player) continue;
					else if (board[r][c+i*x] != player)
					{
						if (board[r][c+i*x+x] == player)
						{
							res -= mGrid[r][c];
						}
					}
					else assert(false);
				}
			}
			
		}
	}

	return res;
}

double Position2_2(const cPlayer player, cBoard& board, cMatrix<double>& mGrid)
{
	double res = 0;
	int r, c;
	for(r=0; r<nROW; r++)
	{
		for(c=0; c<nCOL; c++)
		{
			if (board[r][c] == player)
			{
				res += mGrid[r][c];
			}
		}
	}

	//add extra negative for corner loc
	for(int i=0; i<=4; i++)
	{
		int x, y;
		switch (i)
		{
		case 0: r=0; c=0; x=1; y=1; break;
		case 1: r=nROW-1, c=nCOL-1; x=-1; y=-1; break;
		case 2: r=0; c=nCOL-1; x=-1; y=1; break;
		case 4: r=nROW-1; c=0; x=1; y=-1; break;
		}
	
		if (board[r][c] == gBLANK)
		{

			/*
			//triple the negative for occupying those place diagonally adj to corner
			//since there is only 1 constant, the program should still do findthe "optimial"
			const double MUTIPLIER = 3.0;
			if (board[r+y][c+x] == player)
			{
				res += MUTIPLIER * mGrid[r+y][c+x];
			}
			*/

			const PENALTY = 0.5;

			//don't subtract the adj corner piece if the adj edge piece is player's
			if (board[r+y][c] == player && board[r+2*y][c] == player)
			{
				res -= mGrid[r+y][c] * PENALTY;
			}

			if (board[r][c+x] == player && board[r][c+2*x] == player)
			{
				res -= mGrid[r][c+x] * PENALTY;
			}
			
			//if you press diagonal, you are as good as losing the corner
			if (board[r+y][c+x] == player)
			{
				res -= mGrid[r][c] * PENALTY;
			}
						
			//similary, if you have an edge next to diagonal, i.e _xxx_x__ this is really bad too
			if (board[r+y][c] == player)
			{
				for(int i=2; i<nROW-1; i++)
				{
					if (board[r+i*y][c] == player) continue;
					else if (board[r+i*y][c] != player)
					{
						if (board[r+i*y+y][c] == player)
						{
							res -= mGrid[r][c] * PENALTY;
						}
					}
					else assert(false);
				}
			}

			if (board[r][c+x] == player)
			{
				for(int i=2; i<nCOL-1; i++)
				{
					if (board[r][c+i*x] == player) continue;
					else if (board[r][c+i*x] != player)
					{
						if (board[r][c+i*x+x] == player)
						{
							res -= mGrid[r][c] * PENALTY;
						}
					}
					else assert(false);
				}
			}
			
		}
	}

	return res;
}

double Position3(const cPlayer player, cBoard& board, cMatrix<double>& mGrid)
{
	double res = 0;
	int r, c;
	for(r=0; r<nROW; r++)
	{
		for(c=0; c<nCOL; c++)
		{
			if (board[r][c] == player)
			{
				res += mGrid[r][c];
			}
		}
	}

	//add extra negative for corner loc
	for(int i=0; i<=4; i++)
	{
		int x, y;
		switch (i)
		{
		case 0: r=0; c=0; x=1; y=1; break;
		case 1: r=nROW-1, c=nCOL-1; x=-1; y=-1; break;
		case 2: r=0; c=nCOL-1; x=-1; y=1; break;
		case 4: r=nROW-1; c=0; x=1; y=-1; break;
		}
	
		if (board[r][c] == gBLANK)
		{
			
			//triple the negative for occupying those place diagonally adj to corner
			//since there is only 1 constant, the program should still do fine the "optimial"
			const double MUTIPLIER = 3.0;
			if (board[r+y][c+x] == player)
			{
				res += MUTIPLIER * mGrid[r+y][c+x];
			}

			//don't subtract the adj corner piece if the adj edge piece is player's
			if (board[r+y][c] == player && board[r+2*y][c] == player)
			{
				res -= mGrid[r+y][c];
			}

			if (board[r][c+x] == player && board[r][c+2*x] == player)
			{
				res -= mGrid[r][c+x];
			}
			
			//if you press diagonal, you are as good as losing the corner
			if (board[r+y][c+x] == player)
			{
				res -= mGrid[r][c];
			}
						
			//similary, if you have an edge next to diagonal, i.e _xxx_x__ this is really bad too
			if (board[r+y][c] == player)
			{
				for(int i=2; i<nROW-1; i++)
				{
					if (board[r+i*y][c] == player) continue;
					else if (board[r+i*y][c] == gBLANK)
					{
						if (board[r+i*y+y][c] == player)
						{
							res -= mGrid[r][c];
						}
					}
					else if (board[r+i*y][c] != player) //if it's the other player
					{
						res -= mGrid[r][c];
					}
					else assert(false);
				}
			}

			if (board[r][c+x] == player)
			{
				for(int i=2; i<nCOL-1; i++)
				{
					if (board[r][c+i*x] == player) continue;
					else if (board[r][c+i*x] == gBLANK)
					{
						if (board[r][c+i*x+x] == player)
						{
							res -= mGrid[r][c];
						}
					}
					else if (board[r][c+i*x] != player)
					{
						res -= mGrid[r][c];
					}
					else assert(false);
				}
			}
			
		}
	}

	return res;
}

double Evaluate(const cPlayer player, cBoard& board, cMatrix<double>& mGrid, cMatrix<bool>& mValid)
{
	//decide who's who
	cPlayer other;
	if (player == gBLACK) other = gWHITE;
	else if (player == gWHITE) other = gBLACK;

	//count up the number of pieces
	int nPlayer = board.Count(player);
	int nOther = board.Count(other);

	//if opp has no piece, wonderful
	if (nOther == 0) return INFINITY;

	//if player has no piece, very bad
	if (nPlayer == 0) return -INFINITY;

	//if this is the very end of the game, pieces decide strategy
	//note that this works correctly only when every single leaf of decision tree is evaluated by the below function
	if (nPlayer + nOther == nROW * nCOL)
	{
		return nPlayer - nOther;
	}

	//otherwise, get mobility
	int mobPlayer = Mobility(player, board, mValid);
	int mobOther = Mobility(other, board, mValid);
	int mob = mobPlayer - mobOther;

	//get positional score
	double posPlayer = Position(player, board, mGrid);
	double posOther = Position(other, board, mGrid);
	double pos = posPlayer - posOther;

	return (double(mob) + double(pos));
}

double Evaluate2(const cPlayer player, cBoard& board, cMatrix<double>& mGrid, cMatrix<bool>& mValid)
{
	//decide who's who
	cPlayer other;
	if (player == gBLACK) other = gWHITE;
	else if (player == gWHITE) other = gBLACK;

	//count up the number of pieces
	int nPlayer = board.Count(player);
	int nOther = board.Count(other);

	//if opp has no piece, wonderful
	if (nOther == 0) return INFINITY;

	//if player has no piece, very bad
	if (nPlayer == 0) return -INFINITY;

	//if this is the very end of the game, pieces decide strategy
	//note that this works correctly only when every single leaf of decision tree is evaluated by the below function
	if (nPlayer + nOther == nROW * nCOL)
	{
		return nPlayer - nOther;
	}

	//otherwise, get mobility
	int mobPlayer = Mobility(player, board, mValid);
	int mobOther = Mobility(other, board, mValid);
	int mob = mobPlayer - mobOther;

	//get positional score
	double posPlayer = Position2(player, board, mGrid);
	double posOther = Position2(other, board, mGrid);
	double pos = posPlayer - posOther;

	return (double(mob) + double(pos));
}

double Evaluate3(const cPlayer player, cBoard& board, cMatrix<double>& mGrid, cMatrix<bool>& mValid)
{
	//decide who's who
	cPlayer other;
	if (player == gBLACK) other = gWHITE;
	else if (player == gWHITE) other = gBLACK;

	//count up the number of pieces
	int nPlayer = board.Count(player);
	int nOther = board.Count(other);

	//if opp has no piece, wonderful
	if (nOther == 0) return INFINITY;

	//if player has no piece, very bad
	if (nPlayer == 0) return -INFINITY;

	//if this is the very end of the game, pieces decide strategy
	//note that this works correctly only when every single leaf of decision tree is evaluated by the below function
	if (nPlayer + nOther == nROW * nCOL)
	{
		return nPlayer - nOther;
	}

	//otherwise, get mobility
	int mobPlayer = Mobility(player, board, mValid);
	int mobOther = Mobility(other, board, mValid);
	int mob = mobPlayer - mobOther;

	//get positional score
	double posPlayer = Position2(player, board, mGrid);
	double posOther = Position2(other, board, mGrid);
	double pos = posPlayer - posOther;

	//add a corner bonus, for the one to obtain a corner first 
	double bonus = 0;
	int cPlayer = 0;
	int cOther = 0;
	int r, c;

	r = 0; c = 0;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;
	
	r = nROW-1; c = 0;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;

	r = 0; c = nCOL-1;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;

	r = nROW-1; c = nCOL-1;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;

	//discourage when both has corner, NOTE: I use mGrid[3][3], a middle loc so that it will be adjusted, and it generally has less influence on everything else TODO possibly make this nicer
	if (cPlayer >= 1 && cOther >= 1) bonus = -85.0 * mGrid[3][3];
	
	/*
	//if none of the corner is occupied, and it's late in the game
	if (board[0][0] == gBLANK &&
		board[nROW-1][0] == gBLANK &&
		board[0][nCOL-1] == gBLANK &&
		board[nROW-1][nCOL-1] == gBLANK)
	{
		//if all the diagonal is not occupied by the player
		if (board[1][1] != player &&
			board[nROW-2][1] != player &&
			board[1][nCOL-2] != player &&
			board[nROW-2][nCOL-2] != player)
		{
			//the one with higher mobility gets a corner bonus as the game ends
			//bonus = 20.0 * mGrid[0][0] / (nROW * nCOL - nPlayer - nOther);
			bonus = mGrid[0][0];
			if (mobPlayer > mobOther) bonus *= 1.0; //do nothing
			else if (mobPlayer < mobOther) bonus *= -1.0;
			else bonus = 0;
		}
	}
	*/

	return (double(mob) + double(pos) + bonus);
}

//somehow, the computer start to give away corner if I use this eval fun...!!!
double Evaluate4(const cPlayer player, cBoard& board, cMatrix<double>& mGrid, cMatrix<bool>& mValid)
{
	//decide who's who
	cPlayer other;
	if (player == gBLACK) other = gWHITE;
	else if (player == gWHITE) other = gBLACK;

	//count up the number of pieces
	int nPlayer = board.Count(player);
	int nOther = board.Count(other);

	//if opp has no piece, wonderful
	if (nOther == 0) return INFINITY;

	//if player has no piece, very bad
	if (nPlayer == 0) return -INFINITY;

	//if this is the very end of the game, pieces decide strategy
	//note that this works correctly only when every single leaf of decision tree is evaluated by the below function
	if (nPlayer + nOther == nROW * nCOL)
	{
		return nPlayer - nOther;
	}

	//otherwise, get mobility
	int mobPlayer = Mobility(player, board, mValid);
	int mobOther = Mobility(other, board, mValid);
	int mob = mobPlayer - mobOther;

	//get positional score
	double posPlayer = Position2_2(player, board, mGrid);
	double posOther = Position2_2(other, board, mGrid);
	double pos = posPlayer - posOther;

	//add a corner bonus, for the one to obtain a corner first 
	double bonus = 0;
	int cPlayer = 0;
	int cOther = 0;
	int r, c;

	r = 0; c = 0;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;
	
	r = nROW-1; c = 0;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;

	r = 0; c = nCOL-1;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;

	r = nROW-1; c = nCOL-1;
	if (board[r][c] == player) cPlayer++;
	else if (board[r][c] == other) cOther++;

	//discourage when both has corner, NOTE: I use mGrid[3][3], a middle loc so that it will be adjusted, and it generally has less influence on everything else TODO possibly make this nicer
	/*
	if (cPlayer >= 1 && cOther >= 1)
	{
		//bonus = -85.0 * mGrid[3][3];
		bonus = -5.0;
	}
	*/

	if (cPlayer >= 1 && cOther == 0)
	{
		bonus = 10;
	}
	
	/*
	//if none of the corner is occupied, and it's late in the game
	if (board[0][0] == gBLANK &&
		board[nROW-1][0] == gBLANK &&
		board[0][nCOL-1] == gBLANK &&
		board[nROW-1][nCOL-1] == gBLANK)
	{
		//if all the diagonal is not occupied by the player
		if (board[1][1] != player &&
			board[nROW-2][1] != player &&
			board[1][nCOL-2] != player &&
			board[nROW-2][nCOL-2] != player)
		{
			//the one with higher mobility gets a corner bonus as the game ends
			//bonus = 20.0 * mGrid[0][0] / (nROW * nCOL - nPlayer - nOther);
			bonus = mGrid[0][0];
			if (mobPlayer > mobOther) bonus *= 1.0; //do nothing
			else if (mobPlayer < mobOther) bonus *= -1.0;
			else bonus = 0;
		}
	}
	*/

	return (double(mob) + double(pos) + bonus);
}
